VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsDatForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'======================================================================================================
'Type       :- Class Module
'Name       :- clsDatForm
'Work       :- Populate dataform with fields. _
               In this process we have to add _
               new lables & also textboxes

'Created by :- Sanjaya Rathugama.
'E-mail     :- sanjayapr@hotmail.com
'Created _
 Date       :-
 
'======================================================================================================

Option Explicit

'Private variables in here.

'Object type variables in here.
Private oaField()    As Object

Private txtdcnt      As TextBox
Private lblFldName() As Label
Private fraBckPanel  As Frame
Private cControl     As Control

'Integer type variables in here.
Private nj As Integer

Public Sub Fill_Fields(Df_ResTable, gsSql_Editor_SQL As String, gClsMain As dll_DbCnn.clsMain _
                        , txtFldData, txtdcnt, lblFldName, fraBckPanel, frmSQLEditor, lblRecordCount, bError As Boolean)

'================= Use to populate dataform with fields ===================================

On Error GoTo ErrorHandle 'Trap errors

'Open recordset to fill texboxes with field data. (By textboxes are not added yet.)
Df_ResTable.Open gClsMain.gsSQL, gClsMain.gCnn, adOpenStatic, adLockOptimistic

'Check empty recordset or not
If Df_ResTable.RecordCount = 0 Then
    MsgBox "  No Record(s) to show . ", vbExclamation
    Exit Sub
End If

'****************** This is very important. ******************************************************

'       When I was declare an array to load textboxes  and  labels,
'I didn't know how many  of  them   to   load.  Because  I   didn't
'know how many  fields  in  particular   table  or  view. But after
'opened recordset  we can find how many fields in that recordset.

'So we can load enough textboxes for all fields. So we can use  very
'interesting declaration in the middle of the particular sub. To  do
'that we can use unusual declaraton called ReDim. ReDim does declare
'previous array again.

ReDim oaField(Df_ResTable.Fields.Count)

'*************************************************************************************************

For nj = 1 To Df_ResTable.Fields.Count
    
    'Set an element of arry, with existing textbox (txtFldName(0))
    Set oaField(nj) = txtFldData(nj)
    
    'Load new textbox
    Load oaField(nj)
    
    'Show new textbox
    txtFldData(nj).Visible = True
    
    'Move text boxs in a line and keep little margine among them.
    txtFldData(nj).Top = txtFldData(nj - 1).Top + txtFldData(nj - 1).Height + 50
    
    '------------ Fill textbox with current field's data. ------------------------
    txtFldData(nj) = IIf(IsNull(Df_ResTable(nj - 1).OriginalValue), _
                                "", Df_ResTable(nj - 1).OriginalValue)
    
    '------- Resize textbox using field type. --------
    
    'Get textbox width
    Select Case Df_ResTable(nj - 1).Type
        Case 200
            txtFldData(nj).Width = 4000
        Case 7
            txtFldData(nj).Width = 1500
        Case 201
            txtFldData(nj).Width = 4000
        Case 205
            txtFldData(nj).Width = 3000
        Case 3
            txtFldData(nj).Width = 1500
        Case Else
            txtFldData(nj).Width = 4000
    End Select
    
    'Get textbox heigth
    If Df_ResTable(nj - 1).DefinedSize > 30 And _
                            Not Df_ResTable(nj - 1).Type = 205 Then
        txtFldData(nj).Height = 700
    End If
    
    'Set an element of arry, with existing lable( lblFldName(0))
    Set oaField(nj) = lblFldName(nj)
    
    'Load new lable
    Load oaField(nj)
    
    'Show new textbox
    lblFldName(nj).Visible = True
    
    'Move text boxs in a line and keep little margine among them.
    lblFldName(nj).Top = txtFldData(nj - 1).Top _
                                        + txtFldData(nj - 1).Height + 50
    
    '------------ Fill lables with current field's name. ------------------------
    lblFldName(nj) = IIf(IsNull(Df_ResTable(nj - 1).Name), "", _
                                        Df_ResTable(nj - 1).Name)
    
    'Resize back panel's heigth ( it's a frame. )
    fraBckPanel.Height = txtFldData(nj).Top + 2000

Next

gsSql_Editor_SQL = "Cleared"

Exit Sub

'--------- ErrorHandling & ErrorTraping ------------------------------------------

ErrorHandle:
    'If an error is occured, then show error in sql editor's textbox.
    
    '***** Important :- This part is depend on a form (frmSQLEditor). so this
    '                   class module is completely not independent.
    
    If frmSQLEditor.Visible = True Then
        Beep
        frmSQLEditor.txtSQLEditor = frmSQLEditor.txtSQLEditor & vbCrLf & Error()
        bError = True
    Else
        MsgBox Error(), vbExclamation, frmSQLEditor.Caption
    End If

End Sub

Public Sub move_Next(Df_ResTable, nj As Integer, txtFldData, txtdcnt, Caption)

'================== Move to Next Record. ====================================
On Error GoTo ErrorHandle 'Trap error

'Do move next until end of record set. (Not a loop)
If Not Df_ResTable.EOF = True Then
    Df_ResTable.MoveNext
End If

'Do move next until end of record set. (Not a loop)
If Not Df_ResTable.EOF = True Then
    
    'Fill textboxs with data
    For nj = 1 To Df_ResTable.Fields.Count
        txtFldData(nj) = IIf(IsNull(Df_ResTable(nj - 1).OriginalValue), _
                                    "", Df_ResTable(nj - 1).OriginalValue)
    Next

Else
    'Message shows when pointer reachs end of recordset
    MsgBox "        This is the Last Record.      ", , Caption
    'Move last record to prevet space
    Df_ResTable.MoveLast
End If


Exit Sub

'Handle error
ErrorHandle:
    'Show error discription directly through messagebox
    MsgBox Error(), vbCritical, Caption

End Sub
Public Sub move_Previous(Df_ResTable, nj As Integer, txtFldData, txtdcnt, Caption)

'================== Move to previous Record. ====================================
On Error GoTo ErrorHandle 'Trap error

'Do move previous until begining of record set. (Not a loop)
If Not Df_ResTable.BOF = True Then
    Df_ResTable.MovePrevious
End If

'Do move previous until begining of record set. (Not a loop)
If Not Df_ResTable.BOF = True Then
    
    'Fill textboxs with data
    For nj = 1 To Df_ResTable.Fields.Count
        txtFldData(nj) = IIf(IsNull(Df_ResTable(nj - 1).OriginalValue), _
                                    "", Df_ResTable(nj - 1).OriginalValue)
    Next

Else
    'Message shows when pointer reachs begining of recordset
    MsgBox "        This is the First Record.      ", , Caption
    'Move first record to prevet space
    Df_ResTable.MoveFirst
End If

Exit Sub

'Handle errors
ErrorHandle:
    'Show error discription directly through messagebox
    MsgBox Error(), vbCritical, Caption

End Sub

Public Sub move_Last(Df_ResTable, nj As Integer, txtFldData, txtdcnt, Caption)

'================== Move to last Record. ====================================
On Error GoTo ErrorHandle 'Trap error

'Move to last Record
Df_ResTable.MoveLast

'Fill textboxs with data
For nj = 1 To Df_ResTable.Fields.Count
    txtFldData(nj) = IIf(IsNull(Df_ResTable(nj - 1).OriginalValue), _
                                "", Df_ResTable(nj - 1).OriginalValue)
Next

Exit Sub

'Handle errors
ErrorHandle:
    'Show error discription directly through messagebox
    MsgBox Error(), vbCritical, Caption

End Sub
Public Sub move_First(Df_ResTable, nj As Integer, txtFldData, txtdcnt, Caption)

'================== Move to First Record. ====================================
On Error GoTo ErrorHandle 'Trap error

'Move to first record
Df_ResTable.MoveFirst

'Fill textboxs with data
For nj = 1 To Df_ResTable.Fields.Count
    txtFldData(nj) = IIf(IsNull(Df_ResTable(nj - 1).OriginalValue), _
                            "", Df_ResTable(nj - 1).OriginalValue)
Next

'Handle errors
Exit Sub

ErrorHandle:
    'Show error discription directly through messagebox
    MsgBox Error(), vbCritical, Caption

End Sub

Public Sub Clear_Form(frmDt_Form)
'======== Use to clear all textboxes in the dataform ========================

'****** IMPORTANT :- I found this method (not object's method) around the web
                    'years ago. Unfortunatly I haven't it's author's  name or
                    'source code. ***********


For Each cControl In frmDt_Form
    'Filter only textboxes and clear them.
    If TypeOf cControl Is TextBox Then cControl.Text = vbNullString
Next

End Sub

Public Sub Add_New(nj, Df_ResTable, txtFldData, Caption)

'================== Add new record. ====================================
On Error GoTo ErrorHandle 'Trap error

'Move last record before add new one
'*** We also can ignore this step.
Df_ResTable.MoveLast

'Ready to add new record
Df_ResTable.AddNew

'Get data from data form to fields
For nj = 0 To Df_ResTable.Fields.Count - 1
    Df_ResTable(nj).Value = txtFldData(nj + 1)
Next
'Add record to database
Df_ResTable.Update

'Success message
MsgBox "Record is successfully added.", , Caption

Exit Sub

'Handle errors
ErrorHandle:
    'Show error discription directly through messagebox
    MsgBox Error(), vbCritical, Caption

End Sub


Public Sub Delete_Record(Df_ResTable, nj As Integer, txtFldData, txtdcnt, Caption)

'========== To Delete Record(s). =======================================================
On Error GoTo ErrorHandle

'Delete current record from table.
Df_ResTable.Delete adAffectCurrent

'Success message
MsgBox "Record is successfully deleted.", , Caption

'Move to current last record.
move_Last Df_ResTable, nj, txtFldData, txtdcnt, Caption

Exit Sub

'Handle errors
ErrorHandle:
    'Show error discription directly through messagebox
    MsgBox Error(), vbCritical, Caption

End Sub
